	org 	0000h
	jmp	inicio

	org	0003h
	jmp	led_rti

	org	0013h
	jmp	int1_rti

	org	001bh
	jmp	window_RTI

led_rti:
	mov	A,pulses
	mov	B,#10d
	div	AB
	mov	divs,A
	reti

int1_RTI:
	inc	r0
	reti

window_RTI:
	djnz	r1,not_reached
	push	acc
	push	psw
	;clr	ea		;desabilita interrupcoes
	clr	tr1		;desliga timer1
	mov	th1,#03ch	;zera contador
	mov	tl1,#0b0h	;zera contador
	mov	Pulses,R0	;coloca pulsos contados em sua variavel
	mov	r0,#00h		;zera r0
	setb	tr1		;ativa timer 1
	;setb	ea		;ativa interrupcoes
	mov	r1,#04h		;reinicia contagem de tempo 4 x 50ms = 200ms
	pop	psw
	pop	acc
	reti

not_reached:
	clr	tr1		;desliga timer1
	mov	th1,#03ch	;zera contador
	mov	tl1,#0b0h	;zera contador
	setb	tr1		;ativa timer 1
	reti

inicio:
	mov 	p1,#00h		;leds
	setb 	p3.0		;leds
	setb 	p3.1		;leds
	mov 	p2,#00h		;inicialização das portas e reg que serão utilizados

	mov	TMOD,#00010001b	;Conf timers
	setb	ex0
	setb	ex1		;Ativa a interrupcao no pino INT1
	setb	et1		;ativa a interrupcao do timer 1
	setb	it1		;especifica int1 em falling-edge
	setb	it0
	setb	ea		;Habilita interrupcoes
	mov	r1,#04h		;seta contador de tempo
	mov	r0,#00h		;zera contador de pulso

	mov	th1,#03ch	;zera contador
	mov	tl1,#0b0h	;zera contador
	setb	tr1		;ativa contador
	mov	pulses,#00h	;zera var RPM

	mov	num0,#11000000b	;leds do bcd para cada numero
	mov	num1,#11111001b
	mov	num2,#10100100b
	mov	num3,#10110000b
	mov	num4,#10011001b
	mov	num5,#10010010b
	mov	num6,#10000011b
	mov	num7,#11111000b
	mov	num8,#10000000b
	mov	num9,#10010000b

	mov	A,#67d
	mov	B,#10d
	div	AB
	mov	divs,A

main:
	call	separate
	call	convert_buffers
	call	calc_led
	call	imprime_bcd
	jmp	main

imprime_bcd:
	mov 	p2,buf4		;seta numero desejado na porta 2
	clr 	bcd4		;liga o bcd que será impresso o numero
	call 	checktime	;da um tempinho ligado
	nop
	nop
	nop
	setb 	bcd4		;desliga o bcd setado e vai pra proxima
	nop

	mov 	p2,buf3
	clr 	bcd3
	call 	checktime
	nop
	nop
	nop
	setb 	bcd3
	nop

	mov 	p2,buf2
	clr 	bcd2
	call 	checktime
	nop
	nop
	nop
	setb 	bcd2
	nop

	mov 	p2,buf1
	clr 	bcd1
	call 	checktime
	nop
	nop
	nop
	setb 	bcd1
	nop
	ret

checktime:
	clr 	tf0		;baixa a flag
	;MOV	th0,#0ffh	;debug
	;MOV 	TL0,#0f0h	;debug
	MOV 	TH0,#0dfh	;d8f0 = 10ms @ 12Mhz
	MOV 	TL0,#0f0h	;
	setb 	TR0		;liga t0
	jnb 	tf0,$		;aguarda o tempo
	clr 	TR0		;desliga t0
	ret
separate:			;Quando invocada quebra o valor de Pulses
	mov	buf1,#00h
	mov	pdec,#00h
	mov	punit,#00h
	mov	A,Pulses	;este numero nao pode ser maior que 66 = 9900 RPS = 330 Hz
	jz	fim
	mov	B,#10d
	div	AB
	mov	pdec,A
	mov	punit,B
	mov	A,punit
	mov	B,#05d		;este 5 vem do 150 cabalistico
	mul	AB
	mov	B,#10d		;para separar valor do carry
	div	AB
	mov	buf2,B
	mov	b,punit	;soma unidade com o carry pois seria multiplicaçao por 1 
	add	A,B	;do 150 cabalistico
	mov	B,#10d
	div	AB
	mov	buf3,B
	mov	buf4,A
	mov	A,pdec
	jz	fim		;teste para ver se tem unidade no num. de pulso
	mov	B,#05d		;este 5 vem do 150 cabalistico novamente
	mul	AB
	mov	B,#10d		;para dividir decimal de unidade
	div	AB
	mov	aunit,B
	mov	adec,A
	mov	a,buf3
	add	A,B
	mov	B,#10d
	div	AB
	mov	buf3,B
	mov	B,pdec
	add	A,B
	mov	B,adec
	add	A,B
	mov	B,buf4
	add	A,B
	mov	buf4,A		;Atualiza o valor de buf4
	mov	aunit,#00h	;zera os valores auxiliares
	mov	adec,#00h
fim:	ret

convert_buffers:
	mov	A,buf4
	call	convert_bcd	;retorna em A o codigo BCD do numero
	mov	buf4,A		;coloca o codigo na variavel dele
	mov	A,buf3
	call	convert_bcd	;retorna em A o codigo BCD do numero
	mov	buf3,A		;coloca o codigo na variavel dele
	mov	A,buf2
	call	convert_bcd	;retorna em A o codigo BCD do numero
	mov	buf2,A		;coloca o codigo na variavel dele
	mov	A,buf1
	call	convert_bcd	;retorna em A o codigo BCD do numero
	mov	buf1,A		;coloca o codigo na variavel dele
	ret
convert_bcd:
	cjne	a,#0,um 		;Ã© zero o 2 digito? (primeiro digito cravado sempre em 0)
	mov	a,num0 		;sim logo move zero
	ret
um:	cjne	a,#1,dois
	mov	a,num1
	ret
dois:	cjne	a,#2,tres
	mov	a,num2
	ret
tres:	cjne	a,#3,quatro
	mov	a,num3
	ret
quatro:	cjne	a,#4,cinco
	mov	a,num4
	ret
cinco:	cjne	a,#5,seis
	mov	a,num5
	ret
seis:	cjne	a,#6,sete
	mov	a,num6
	ret
sete:	cjne	a,#7,oito
	mov	a,num7
	ret
oito:	cjne	a,#8,nove
	mov	a,num8
	ret
nove:	mov	a,num9 		;nenhum anterior? soh pode ser o nove
	ret

calc_led:
	mov	A,pulses		;move pulsos lidos
	mov	B,divs		;move divisor calculado
	div	ab
	jz	zero
	cjne	A,#10d,tmu	;todos menos um
	mov 	p2,#00h		;leds
	clr 	p3.0		;leds
	clr 	p3.1		;leds
	ret

tmu:	cjne	A,#09d,soh8
	mov 	p2,#00h		;leds
	clr 	p3.0		;leds
	setb 	p3.1		;leds
	ret

soh8:
	mov	numled,A		;Salva numero de leds que tem que acender
	mov	a,#0ffh
	setb	p3.0
	setb	p3.2
soh8_2:
	rl	A
	dec	A
	djnz	numled,soh8_2
	mov	p1,A
	ret
zero:	setb	p3.0
	setb	p3.1
	mov	p1,#0ffh
	ret

;begin defines

buf1 	equ	1Ah	;Posiçoes que a rotina imprime_bcd le
buf2 	equ 	1Bh	;em ordem buf1 unidade 2 dezena
buf3 	equ 	1Ch	;buf3 centena e buf4 milhar
buf4 	equ 	1Dh
punit	equ	1Eh	;parte unitaria do pulso
pdec	equ	1Fh	;parte decimal do pulso se for maior que 9
aunit	equ	20h	;unidade auxiliar
adec	equ	21h	;decimal auxiliar

Pulses	equ	22h
Pul_old	equ	23h
Divs	equ	24h
numled	equ	25h

bcd1 	equ 	p3.4	;portas do chaveamento bcd
bcd2 	equ 	p3.5
bcd3 	equ 	p3.6
bcd4 	equ 	p3.7

led1	bit	p1.0
led2	bit	p1.1
led3	bit	p1.2
led4	bit	p1.3
led5	bit	p1.4
led6	bit	p1.5
led7	bit	p1.6
led8	bit	p1.7
led9	bit	p3.0
led10	bit	p3.1

num0 	equ	10h	;leds do bcd para cada numero
num1 	equ	11h
num2 	equ	12h
num3 	equ	13h
num4 	equ	14h
num5 	equ	15h
num6 	equ 	16h
num7 	equ 	17h
num8 	equ 	18h
num9 	equ 	19h

END
